=== debian/changelog ===
rr (4.1.0-2) unstable; urgency=medium

  * Add missing build-dependency on gdb (with thanks to the ever-
    vigilant Chris Lamb; closes: #814211).

 -- Stephen Kitt <skitt@debian.org>  Tue, 09 Feb 2016 10:45:20 +0100

rr (4.1.0-1) unstable; urgency=medium

  * New upstream release (now supporting Skylake CPUs).
  * Switch to https: VCS URIs (see #810378).

 -- Stephen Kitt <skitt@debian.org>  Mon, 08 Feb 2016 23:39:35 +0100

rr (4.0.3-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Mon, 23 Nov 2015 08:38:45 +0100

rr (4.0.2-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Wed, 11 Nov 2015 12:09:26 +0100

rr (4.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Update the rr manpage.
  * Update README.Debian (closes: #803231).

 -- Stephen Kitt <skitt@debian.org>  Mon, 02 Nov 2015 14:00:47 +0100

rr (4.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Install the supporting binaries to /usr/lib/rr instead of /usr/bin.
  * Update rr manpage and add one for signal-rr-recording.

 -- Stephen Kitt <skitt@debian.org>  Wed, 28 Oct 2015 00:12:49 +0100
