=== debian/control ===
Source: rr
Section: devel
Priority: optional
Maintainer: Stephen Kitt <skitt@debian.org>
Build-Depends:
 autotools-dev,
 cmake,
 debhelper (>= 9),
 g++-multilib,
 gdb,
 libdisasm-dev,
 libpfm4-dev,
 pkg-config,
 python,
 python-pexpect,
 zlib1g-dev,
# The following are required for the test suite
# realpath
Standards-Version: 3.9.6
Homepage: http://rr-project.org
Vcs-Git: https://anonscm.debian.org/git/collab-maint/rr.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/rr.git

Package: rr
Architecture: amd64 i386
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: application execution recorder, player and debugger
 rr allows application executions to be recorded and then replayed
 with gdb as many times as desired.
 .
 This allows intermittent, or complex to reproduce, bugs to be
 captured and then debugged at leisure. Replays are deterministic,
 always identical from one run to another.
 .
 rr is incompatible with ptrace hardening, and currently only supports
 Intel Nehalem, Westmere, Sandy Bridge, Ivy Bridge, Haswell, Broadwell
 and Skylake CPUs.
