=== debian/watch ===
version=3

opts="filenamemangle=s/(?:.*)?v?(\d[\d\.]*)\.tar\.gz/rr-$1.tar.gz/,dversionmangle=s/\+dfsg$//" \
 https://github.com/mozilla/rr/tags (?:.*/)?v?(\d[\d\.]*)\.tar\.gz
