=== debian/changelog ===
rr (4.3.0-1) unstable; urgency=medium

  * New upstream release:
    - drop scheduler-math.h.patch, merged upstream;
    - refresh move-librrpreload.patch and move-page-exec-stub.patch
      (upstream installs its binaries stubs in /usr/bin now, prefixed with
      rr_; this package installs them in /usr/lib/rr instead).

 -- Stephen Kitt <skitt@debian.org>  Thu, 30 Jun 2016 20:09:45 +0200

rr (4.2.0-2) unstable; urgency=medium

  * Include math.h in Scheduler.cc (closes: #822496).
  * Standards-Version 3.9.8, no change required.

 -- Stephen Kitt <skitt@debian.org>  Mon, 25 Apr 2016 21:06:50 +0200

rr (4.2.0-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version 3.9.7, no change required.

 -- Stephen Kitt <skitt@debian.org>  Thu, 17 Mar 2016 21:07:51 +0100
