=== debian/rules ===
--- 
+++ 
@@ -13,8 +13,7 @@
 override_dh_auto_install:
 	dh_auto_install
 	mv debian/rr/usr/bin/signal-rr-recording.sh debian/rr/usr/bin/signal-rr-recording
-	mv debian/rr/usr/bin/exec_stub* debian/rr/usr/lib/rr/
-	mv debian/rr/usr/bin/rr_page_* debian/rr/usr/lib/rr/
+	mv debian/rr/usr/bin/rr_* debian/rr/usr/lib/rr/
 
 %:
 	dh $@ --with autotools-dev --buildsystem=cmake
