## rr 4.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,18 +22,18 @@
 # debian is happy with it.  However, "_" is illegal in debs, while RPM
 # is cool with it.  Sigh.
 set(rr_VERSION_MAJOR 4)
-set(rr_VERSION_MINOR 3)
+set(rr_VERSION_MINOR 4)
 set(rr_VERSION_PATCH 0)
 
 add_definitions(-DRR_VERSION="${rr_VERSION_MAJOR}.${rr_VERSION_MINOR}.${rr_VERSION_PATCH}")
 
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread -g3 -Wall -Wextra -Wstrict-prototypes")
-set(CMAKE_C_FLAGS_DEBUG "-O0 -Werror")
+set(CMAKE_C_FLAGS_DEBUG "-O0 -Werror -DDEBUG")
 set(CMAKE_C_FLAGS_RELEASE "-O2")
 # Define __STDC_LIMIT_MACROS so |#include <stdint.h>| works as expected.
 # Define __STDC_FORMAT_MACROS so |#include <inttypes.h>| works as expected.
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__USE_LARGEFILE64 -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++0x -pthread -g3 -Wall -Wextra")
-set(CMAKE_CXX_FLAGS_DEBUG "-O0 -Werror")
+set(CMAKE_CXX_FLAGS_DEBUG "-O0 -Werror -DDEBUG")
 set(CMAKE_CXX_FLAGS_RELEASE "-O2")
 set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -g3")
 
@@ -150,10 +150,17 @@
   endif()
 endif()
 
+set(PRELOAD_COMPILE_FLAGS "-fno-stack-protector")
+
+if (NOT DEBUG_PRELOAD_LIB)
+set(PRELOAD_COMPILE_FLAGS "${PRELOAD_COMPILE_FLAGS} ${CMAKE_C_FLAGS_RELEASE}")
+endif()
+
 set_source_files_properties(src/preload/preload.c
-                            PROPERTIES COMPILE_FLAGS ${CMAKE_C_FLAGS_RELEASE})
+                            PROPERTIES COMPILE_FLAGS ${PRELOAD_COMPILE_FLAGS})
 
 include_directories("${PROJECT_SOURCE_DIR}/include")
+include_directories("${PROJECT_SOURCE_DIR}/third-party/proc-service")
 # We need to know where our generated files are.
 include_directories("${CMAKE_CURRENT_BINARY_DIR}")
 
@@ -245,9 +252,11 @@
   src/kernel_metadata.cc
   src/log.cc
   src/MagicSaveDataMonitor.cc
+  src/MmappedFileMonitor.cc
   src/MonitoredSharedMemory.cc
   src/Monkeypatcher.cc
   src/PerfCounters.cc
+  src/ProcFdDirMonitor.cc
   src/ProcMemMonitor.cc
   src/PsCommand.cc
   src/RecordCommand.cc
@@ -269,6 +278,7 @@
   src/StdioMonitor.cc
   src/Task.cc
   src/TaskGroup.cc
+  src/ThreadDb.cc
   src/TraceFrame.cc
   src/TraceStream.cc
   src/VirtualPerfCounterMonitor.cc
@@ -311,7 +321,8 @@
 
 add_executable(rr_exec_stub src/exec_stub.c)
 post_build_executable(rr_exec_stub)
-set_target_properties(rr_exec_stub PROPERTIES LINK_FLAGS -nostdlib)
+set_target_properties(rr_exec_stub
+                      PROPERTIES LINK_FLAGS "-nostartfiles -nodefaultlibs")
 set_source_files_properties(src/exec_stub.c
                             COMPILE_FLAGS "-fno-stack-protector")
 
@@ -340,13 +351,3 @@
 install(PROGRAMS scripts/signal-rr-recording.sh
                   ${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64
                   ${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64_replay
-                  ${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_32
-                  ${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_32_replay
-  DESTINATION bin)
-
-install(TARGETS rr ${RR_BIN} rrpreload rr_exec_stub
-  RUNTIME DESTINATION bin
-  LIBRARY DESTINATION lib
-  ARCHIVE DESTINATION lib)
-
-# Build 32-bit librrpreload on 64-bit builds.
