=== debian/changelog ===
rr (4.4.0-2) unstable; urgency=medium

  * Disable PIE (closes: #844871).
  * Switch to debhelper compatibility level 10.

 -- Stephen Kitt <skitt@debian.org>  Mon, 28 Nov 2016 23:10:02 +0100

rr (4.4.0-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Sat, 01 Oct 2016 15:47:05 +0200
