=== debian/control ===
--- 
+++ 
@@ -2,9 +2,8 @@
 Maintainer: Stephen Kitt <skitt@debian.org>
 Section: devel
 Priority: optional
-Build-Depends: autotools-dev,
-               cmake,
-               debhelper (>= 9),
+Build-Depends: cmake,
+               debhelper (>= 10),
                g++-multilib,
                gdb,
                libdisasm-dev,
