=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,9 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
+
+# rr doesn't build with PIE
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie
 
 export DH_OPTIONS += -O-Bbuild
 
@@ -16,4 +19,4 @@
 	mv debian/rr/usr/bin/rr_* debian/rr/usr/lib/rr/
 
 %:
-	dh $@ --with autotools-dev --buildsystem=cmake
+	dh $@ --buildsystem=cmake
