## rr 4.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,31 +14,34 @@
 set(BUILD_SHARED_LIBS ON)
 
 set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
-set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)
-
-set(WILL_RUN_TESTS ON CACHE BOOL "Run tests")
+set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib/rr)
+
+set(BUILD_TESTS ON CACHE BOOL "Build tests")
+set(WILL_RUN_TESTS ${BUILD_TESTS} CACHE BOOL "Run tests")
 
 # CAREFUL!  "-" is an invalid character in RPM package names, while
 # debian is happy with it.  However, "_" is illegal in debs, while RPM
 # is cool with it.  Sigh.
 set(rr_VERSION_MAJOR 4)
-set(rr_VERSION_MINOR 4)
+set(rr_VERSION_MINOR 5)
 set(rr_VERSION_PATCH 0)
 
 add_definitions(-DRR_VERSION="${rr_VERSION_MAJOR}.${rr_VERSION_MINOR}.${rr_VERSION_PATCH}")
 
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread -g3 -Wall -Wextra -Wstrict-prototypes")
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread -g3 -Wall -Wextra -Wstrict-prototypes -std=gnu11")
 set(CMAKE_C_FLAGS_DEBUG "-O0 -Werror -DDEBUG")
 set(CMAKE_C_FLAGS_RELEASE "-O2")
 # Define __STDC_LIMIT_MACROS so |#include <stdint.h>| works as expected.
 # Define __STDC_FORMAT_MACROS so |#include <inttypes.h>| works as expected.
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__USE_LARGEFILE64 -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++0x -pthread -g3 -Wall -Wextra")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__USE_LARGEFILE64 -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++11 -pthread -g3 -Wall -Wextra")
 set(CMAKE_CXX_FLAGS_DEBUG "-O0 -Werror -DDEBUG")
 set(CMAKE_CXX_FLAGS_RELEASE "-O2")
 set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -g3")
 
+if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-command-line-argument")
+endif()
 if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
-  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-command-line-argument")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-command-line-argument")
 endif()
 
@@ -112,6 +115,11 @@
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${${PKG}_CFLAGS}")
 endforeach(required_lib)
 
+find_path(SECCOMP NAMES "linux/seccomp.h")
+if(NOT SECCOMP)
+  message(FATAL_ERROR "Couldn't find linux/seccomp.h. You may need to upgrade your kernel.")
+endif()
+
 # Check for Python >=2.7 but not Python 3.
 find_package(PythonInterp 2.7 REQUIRED)
 if(PYTHON_VERSION_MAJOR GREATER 2)
@@ -126,6 +134,10 @@
 
 # Check for required Python modules
 if(WILL_RUN_TESTS)
+  if(NOT BUILD_TESTS)
+    message(FATAL_ERROR "Running tests requires building them")
+  endif()
+
   set(REQUIRED_PYTHON_MODULES
     pexpect
   )
@@ -238,6 +250,7 @@
   src/ExtraRegisters.cc
   src/fast_forward.cc
   src/FdTable.cc
+  src/FileMonitor.cc
   src/Flags.cc
   src/ftrace.cc
   src/GdbCommand.cc
@@ -271,6 +284,7 @@
   src/replay_syscall.cc
   src/ReplayTask.cc
   src/ReplayTimeline.cc
+  src/RerunCommand.cc
   src/ReturnAddressList.cc
   src/Scheduler.cc
   src/SeccompFilterRewriter.cc
@@ -297,15 +311,20 @@
 option(RR_BUILD_SHARED "Build the rr shared library as well as the binary (experimental).")
 if(RR_BUILD_SHARED)
   add_library(rr ${RR_SOURCES})
+  set_target_properties(rr PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
   add_executable(rrbin src/main.cc)
   set(RR_BIN rrbin)
   post_build_executable(rrbin)
   set_target_properties(rrbin PROPERTIES OUTPUT_NAME rr)
   target_link_libraries(rrbin rr)
+  install(TARGETS rr
+    RUNTIME DESTINATION bin
+    LIBRARY DESTINATION lib
+    ARCHIVE DESTINATION lib)
 else()
   add_executable(rr ${RR_SOURCES} src/main.cc)
   post_build_executable(rr)
-  set(RR_BIN)
+  set(RR_BIN rr)
 endif()
 add_dependencies(rr Generated Pages)
 
@@ -322,7 +341,7 @@
 add_executable(rr_exec_stub src/exec_stub.c)
 post_build_executable(rr_exec_stub)
 set_target_properties(rr_exec_stub
-                      PROPERTIES LINK_FLAGS "-nostartfiles -nodefaultlibs")
+                      PROPERTIES LINK_FLAGS "-static -nostartfiles -nodefaultlibs")
 set_source_files_properties(src/exec_stub.c
                             COMPILE_FLAGS "-fno-stack-protector")
 
@@ -330,24 +349,3 @@
   32bit-avx.xml
   32bit-core.xml
   32bit-linux.xml
-  32bit-sse.xml
-  64bit-avx.xml
-  64bit-core.xml
-  64bit-linux.xml
-  64bit-sse.xml
-  amd64-avx-linux.xml
-  amd64-linux.xml
-  i386-avx-linux.xml
-  i386-linux.xml
-)
-foreach(file ${RR_GDB_RESOURCES})
-  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/third-party/gdb/${file}"
-                 "${CMAKE_CURRENT_BINARY_DIR}/share/rr/${file}"
-                 COPYONLY)
-  install(FILES third-party/gdb/${file}
-          DESTINATION share/rr)
-endforeach(file)
-
-install(PROGRAMS scripts/signal-rr-recording.sh
-                  ${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64
-                  ${CMAKE_CURRENT_BINARY_DIR}/bin/rr_page_64_replay
