=== debian/changelog ===
rr (4.5.0-1) unstable; urgency=medium

  * New upstream release, merging move-librrpreload.patch.
  * Update watch file.
  * Import upstream fix to build with GCC 7 (closes: #853646).
  * Standards-Version 4.0.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 24 Jun 2017 23:10:55 +0200
