=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
                zlib1g-dev
 # The following are required for the test suite
 # realpath
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/rr.git
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/rr.git
 Homepage: http://rr-project.org
